/*
 * Center:  34
 * Subcenter: 241
 * Parameter table version: 200 
 */

TBLE2 jra55_params[] = {
{1, "Pressure", "Pa", "PRES"},
{2, "Pressure reduced to MSL", "Pa", "PRMSL"},
{4, "Potential vorticity", "K*m^2/kg/s", "pVOR"},
{6, "Geopotential", "m^2/s^2", "GP"},
{7, "Geopotential height", "gpm", "HGT"},
{10, "Total ozone", "Dobson", "TOZNE"},
{11, "Temperature", "K", "TMP"},
{13, "Potential temperature", "K", "POT"},
{15, "Maximum temperature", "K", "TMAX"},
{16, "Minimum temperature", "K", "TMIN"},
{18, "Dew-point depression", "K", "DEPR"},
{33, "u-component of wind", "m/s", "UGRD"},
{34, "v-component of wind", "m/s", "VGRD"},
{35, "Stream function", "m^2/s", "STRM"},
{36, "Velocity potential", "m^2/s", "VPOT"},
{37, "Montgomery stream function", "m^2/s^2", "MNTSF"},
{39, "Vertical velocity", "Pa/s", "VVEL"},
{43, "Relative vorticity", "1/s", "RELV"},
{44, "Relative divergence", "1/s", "RELD"},
{51, "Specific humidity", "kg/kg", "SPFH"},
{52, "Relative humidity", "%", "RH"},
{54, "Precipitable water", "kg/m^2", "PWAT"},
{57, "Evaporation", "mm/day", "EVP"},
{58, "Cloud ice", "kg/m^2", "CICE"},
{61, "Total precipitation", "mm/day", "TPRAT"},
{62, "Large scale precipitation", "mm/day", "LPRAT"},
{63, "Convective precipitation", "mm/day", "CPRAT"},
{64, "Snowfall rate water equivalent", "mm/day", "SRWEQ"},
{65, "Water equivalent of accumulated snow depth", "kg/m^2", "SnWe"},
{66, "Snow depth", "m", "SnowD"},
{71, "Total cloud cover", "%", "TCDC"},
{73, "Low cloud cover", "%", "LCDC"},
{74, "Medium cloud cover", "%", "MCDC"},
{75, "High cloud cover", "%", "HCDC"},
{81, "Land cover (1 = land, 0 = sea)", "Proportion", "LAND"},
{83, "Surface roughness", "m", "SFCR"},
{85, "Soil temperature", "K", "SoilT"},
{90, "Water run-off", "mm/day", "ROF"},
{91, "Ice cover (1 = ice, 0 = no ice)", "Proportion", "ICEC"},
{118, "Brightness temperature", "K", "BRTMP"},
{121, "Latent heat flux", "W/m^2", "LHTFL"},
{122, "Sensible heat flux", "W/m^2", "SHTFL"},
{124, "Momentum flux, u-component", "N/m^2", "UFLX"},
{125, "Momentum flux, v-component", "N/m^2", "VFLX"},
{132, "Square of Brunt-Vaisala frequency", "1/s^2", "BVF2"},
{144, "Canopy temperature", "K", "TSC"},
{145, "Ground temperature", "K", "TSG"},
{146, "Cloud work function", "J/kg", "CWORK"},
{147, "Zonal momentum flux by long gravity wave", "N/m^2", "FGLU"},
{148, "Meridional momentum flux by long gravity wave", "N/m^2", "FGLV"},
{151, "Adiabatic zonal acceleration", "m/s/day", "ADUA"},
{152, "Meridional water vapour flux", "Kg/m/s", "VWV"},
{154, "Meridional momentum flux by short gravity wave", "N/m^2", "FGSV"},
{155, "Ground heat flux", "W/m^2", "GFLX"},
{157, "Zonal water vapour flux", "kg/m/s", "UWV"},
{159, "Zonal momentum flux by short gravity wave", "N/m^2", "FGSU"},
{160, "Clear sky upward solar radiation flux", "W/m^2", "CSUSF"},
{161, "Clear sky downward solar radiation flux", "W/m^2", "CSDSF"},
{162, "Clear sky upward long wave radiation flux", "W/m^2", "CSULF"},
{163, "Clear sky downward long wave radiation flux", "W/m^2", "CSDLF"},
{165, "Adiabatic meridional acceleration", "m/s/day", "ADVA"},
{170, "Frequency of deep convection", "%", "FRCV"},
{171, "Frequency of shallow convection", "%", "FRCVS"},
{172, "Frequency of stratocumulus parameterisation", "%", "FRSC"},
{173, "Gravity wave zonal acceleration", "m/s/day", "GWDUA"},
{174, "Gravity wave meridional acceleration", "m/s/day", "GWDVA"},
{190, "Zonal thermal energy flux", "W/m", "UTHE"},
{191, "Meridional thermal energy flux", "W/m", "VTHE"},
{202, "Evapotranspiration", "W/m^2", "LTRS"},
{203, "Interception loss", "W/m^2", "LINT"},
{204, "Downward solar radiation flux", "W/m^2", "DSWRF"},
{205, "Downward long wave radiation flux", "W/m^2", "DLWRF"},
{211, "Upward solar radiation flux", "W/m^2", "USWRF"},
{212, "Upward long wave radiation flux", "W/m^2", "ULWRF"},
{219, "Maximum wind speed", "m/s", "WSMX"},
{221, "Cloud water", "kg/kg", "CWAT"},
{222, "Adiabatic heating rate", "K/day", "ADHR"},
{223, "Moisture storage on canopy", "m", "MSC"},
{224, "Moisture storage on ground/cover", "m", "MSG"},
{225, "Soil wetness", "Proportion", "SoilW"},
{226, "Mass concentration of condensed water in soil", "kg/m^3", "SMC"},
{227, "Cloud liquid water", "kg/m^2", "CW"},
{228, "Cloud liquid water", "kg/kg", "CLWC"},
{229, "Cloud ice", "kg/kg", "CIWC"},
{230, "Upward mass flux at cloud base", "kg/m^2/s", "MFLXB"},
{231, "Upward mass flux", "kg/m^2/s", "MFLUX"},
{236, "Adiabatic moistening rate", "kg/kg/day", "ADMR"},
{237, "Ozone mixing ratio", "mg/kg", "OZONE"},
{239, "Convective zonal acceleration", "m/s/day", "CNVUA"},
{240, "Convective meridional acceleration", "m/s/day", "CNVVA"},
{241, "Large scale condensation heating rate", "K/day", "LRGHR"},
{242, "Convective heating rate", "k/day", "CNVHR"},
{243, "Convective moistening rate", "kg/kg/day", "CNVMR"},
{246, "Vertical diffusion heating rate", "K/day", "VDFHR"},
{247, "Vertical diffusion zonal acceleration", "m/s/day", "VDFUA"},
{248, "Vertical diffusion meridional acceleration", "m/s/day", "VDFVA"},
{249, "Vertical diffusion moistening rate", "kg/kg/day", "VDFMR"},
{250, "Solar radiative heating rate", "k/day", "SWHR"},
{251, "Long wave radiative heating rate", "K/day", "LWHR"},
{253, "Large scale moistening rate", "kg/kg/day", "LRGMR"}
};
